<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglContainersSubgraphBase.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_5e9011f35b9434939eeeb25c7dbf1304.html">containers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglContainersSubgraphBase.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglContainersSubgraphBase_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLSUBGRAPHBASE_HPP_</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLSUBGRAPHBASE_HPP_</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#ifdef CMEM_ENABLE</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &quot;tiglMemMsmcAllocator.hpp&quot;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &quot;tiglMemDdrAllocator.hpp&quot;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"> * TIGLContainersPosInfo class</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classTIGLContainersPosInfo.html">   75</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo</a></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;{</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo&lt;ID_TYPE&gt;</a> <a class="code" href="classTIGLContainersPosInfo.html">POS_INFO_TYPE</a>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;   <a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo</a>(ID_TYPE inId, uint_fast32_t inPos);</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo</a>(<a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo&lt;T&gt;</a> &amp; inPos);</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;   ~<a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo</a>();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="classTIGLContainersPosInfo.html#a6aa7688f9791cd0049cabb4a583fb081">  102</a></span>&#160;   ID_TYPE <a class="code" href="classTIGLContainersPosInfo.html#a6aa7688f9791cd0049cabb4a583fb081">id</a>;</div>
<div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="classTIGLContainersPosInfo.html#ad4cd7f13b6c52337b28ce7032063d76d">  104</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersPosInfo.html#ad4cd7f13b6c52337b28ce7032063d76d">pos</a>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;   <span class="keyword">inline</span> ID_TYPE getId();</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;   <span class="keyword">inline</span> uint_fast32_t getPos();</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;   <span class="comment">// overloading operator</span></div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&lt;(<a class="code" href="classTIGLContainersPosInfo.html">POS_INFO_TYPE</a> &amp; rhs)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;   {</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &lt; rhs.getId();</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;   }</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&lt;=(POS_INFO_TYPE &amp; rhs)</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;   {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &lt;= rhs.getId();</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;   }</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator==(POS_INFO_TYPE &amp; rhs)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;   {</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> == rhs.getId();</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator!=(POS_INFO_TYPE &amp; rhs)</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;   {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> != rhs.getId();</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   }</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&gt;(POS_INFO_TYPE &amp; rhs)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;   {</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &gt; rhs.getId();</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;   }</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&gt;=(POS_INFO_TYPE &amp; rhs)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;   {</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &gt;= rhs.getId();</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;   }</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&lt;(ID_TYPE idRhs)</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;   {</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="preprocessor">#ifdef CMEM_ENABLE</span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="comment">//      cout &lt;&lt; &quot;$$$ id = &quot; &lt;&lt; id &lt;&lt; &quot;, idRhs = &quot; &lt;&lt; idRhs &lt;&lt; endl;</span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &lt; idRhs;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;   }</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&lt;=(ID_TYPE idRhs)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &lt;= idRhs;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   }</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator==(ID_TYPE idRhs)</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;   {</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> == idRhs;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;   }</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator!=(ID_TYPE idRhs)</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;   {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> != idRhs;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;   }</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&gt;(ID_TYPE idRhs)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;   {</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &gt; idRhs;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;   }</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> operator&gt;=(ID_TYPE idRhs)</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;   {</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;      <span class="keywordflow">return</span> <span class="keywordtype">id</span> &gt;= idRhs;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   }</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;};</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keywordtype">bool</span> posCompare(<a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo&lt;ID_TYPE&gt;</a> lhs, <a class="code" href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo&lt;ID_TYPE&gt;</a> rhs);</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="comment"> * TIGLContainersSubgraphBase class</span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00189"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html">  189</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;{</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="comment">    * type definitions</span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="structTIGLContainersGraphTraits.html">TIGLContainersGraphTraits&lt;CVertex&gt;</a> <a class="code" href="structTIGLContainersGraphTraits.html">trait_type</a>;</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::EDGE_TYPE EDGE_TYPE;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::FAST_LIST_TYPE VERTEX_LIST_TYPE;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;   <span class="keyword">typedef</span> VERTEX_LIST_TYPE * VERTEX_LIST_PTR;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> trait_type::FAST_VERTEX_ITERATOR VERTEX_ITERATOR;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;   <span class="keyword">typedef</span> <a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> <a class="code" href="classTIGLContainersVertexBase.html">VERTEX_TYPE</a>;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="preprocessor">#ifdef CMEM_ENABLE</span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;   <span class="keyword">typedef</span> TIGLMemDdrAllocator&lt;TIGLContainersPosInfo&lt;ID_TYPE&gt; &gt; ALLOCATOR_TYPE;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;   <span class="keyword">typedef</span> allocator&lt;TIGLContainersPosInfo&lt;ID_TYPE&gt; &gt; ALLOCATOR_TYPE;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;   <span class="keyword">typedef</span> vector&lt;TIGLContainersPosInfo&lt;ID_TYPE&gt;, ALLOCATOR_TYPE&gt; INDEX_ELEMENT;   <span class="comment">// //typedef map&lt;ID_TYPE, uint_fast32_t, less&lt;ID_TYPE&gt;, ALLOCATOR_TYPE&gt;  INDEX_ELEMENT; // typedef map&lt;ID_TYPE, uint_fast32_t, less&lt;ID_TYPE&gt; &gt;   INDEX_ELEMENT;//</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> INDEX_ELEMENT::iterator INDEX_ITERATOR;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;   <span class="keyword">typedef</span> vector&lt;INDEX_ELEMENT, ALLOCATOR_TYPE&gt; POS_LIST_TYPE;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="comment">    * constructor/destructor</span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;   <a class="code" href="classTIGLContainersSubgraphBase.html#aa808fe135a0ae28b9b9538254b267d81">TIGLContainersSubgraphBase</a>(<span class="keywordtype">bool</span> isDireted = <span class="keyword">true</span>, ID_TYPE assignedHashSize = 0);</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;   <a class="code" href="classTIGLContainersSubgraphBase.html#aa808fe135a0ae28b9b9538254b267d81">TIGLContainersSubgraphBase</a>(VERTEX_LIST_TYPE &amp; init_adj_list, <span class="keywordtype">bool</span> isDireted, ID_TYPE assignedHashSize = 0);</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;   ~<a class="code" href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a>();</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;<span class="comment">    * attributes</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00231"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html#a56b37400e7d47e6a278084defcd26778">  231</a></span>&#160;   VERTEX_LIST_TYPE <a class="code" href="classTIGLContainersSubgraphBase.html#a56b37400e7d47e6a278084defcd26778">vertexList</a>;</div>
<div class="line"><a name="l00233"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html#a03aff1a6c6f8bac92420673d84542e2a">  233</a></span>&#160;   POS_LIST_TYPE <a class="code" href="classTIGLContainersSubgraphBase.html#a03aff1a6c6f8bac92420673d84542e2a">vertexPos</a>;   <span class="comment">//INDEX_ELEMENT * vertexPos;//</span></div>
<div class="line"><a name="l00235"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html#ad395cc63b17e2c2bed0e47c044d5aeea">  235</a></span>&#160;<span class="comment"></span>   vector&lt;uint_fast32_t&gt; <a class="code" href="classTIGLContainersSubgraphBase.html#ad395cc63b17e2c2bed0e47c044d5aeea">posHoles</a>;</div>
<div class="line"><a name="l00237"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html#a36346fc960bbe56f1ce1ab9d0f9f9fca">  237</a></span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a36346fc960bbe56f1ce1ab9d0f9f9fca">flagDirected</a>;</div>
<div class="line"><a name="l00239"></a><span class="lineno"><a class="line" href="classTIGLContainersSubgraphBase.html#a4d2dc5c71e000a5a43abfb541b99ea97">  239</a></span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#a4d2dc5c71e000a5a43abfb541b99ea97">posHashSize</a>;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;   <span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="comment">    * methods</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="comment">    *</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="comment">    ******************************************************************************/</span></div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;   <span class="keywordtype">void</span> AllocPosTable();</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersSubgraphBase.html#ac45e55c7e818ee8db6456ee80b54f4cb">DeallocPosTable</a>();</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;   <span class="keyword">inline</span> ID_TYPE <a class="code" href="classTIGLContainersSubgraphBase.html#aaee9da2b9d250740c0407d449b2b3a4c">hash</a>(ID_TYPE &amp; <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a7d861bdd7ba46573c8dc83f3bf1e4670">exist</a>(ID_TYPE <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersSubgraphBase.html#ae212d67e8129f85b2e4761aae98de3c0">reset</a>();</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#ae5e592a368623209324164edc1317c65">findPos</a>(ID_TYPE &amp; <span class="keywordtype">id</span>, uint_fast32_t &amp; pos);</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;   <span class="keywordtype">int</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aaeab2fc8f6ebf89e4e055d92972e92da">addVertex</a>(<a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> &amp; x);</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a19e7dea824e424684b5f4d7b75aa96df">createVerticesList</a>(ID_TYPE &amp; numVertices);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aaeab2fc8f6ebf89e4e055d92972e92da">addVertex</a>(ID_TYPE &amp; <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a5833ead8d95633e6a1012b1e93e7b3aa">addVertex_consistent</a>(<a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> &amp; x);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a802c364b5f7d1d6b58ba1d85eec70003">removeVertex</a>(ID_TYPE &amp; <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aca2763f8932ad1ec01be6f4db7231413">addOutEdge</a>(ID_TYPE src, ID_TYPE target);</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aca2763f8932ad1ec01be6f4db7231413">addOutEdge</a>(ID_TYPE src, EDGE_TYPE edge);</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aa8d1a727fba68cd0778e11ba7a36a58e">addInEdge</a>(ID_TYPE src, ID_TYPE target);</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aa8d1a727fba68cd0778e11ba7a36a58e">addInEdge</a>(ID_TYPE target, EDGE_TYPE edge);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a6b753a0835bd3c53821161f728ff2ec7">removeOutEdge</a>(ID_TYPE src, ID_TYPE target);</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aa1c6226429fec67e1dd4e7f368d9ede0">removeInEdge</a>(ID_TYPE src, ID_TYPE target);</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#abbcd66caf3a82f115e13ad0f0a02fa1e">getNumVertices</a>();</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;   ID_TYPE <a class="code" href="classTIGLContainersSubgraphBase.html#adef090617cef9e01d43ed541e8944c80">getNumEdges</a>();</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#af433f6fa9252112db0e30a3f5977a683">getVertex</a>(ID_TYPE &amp; <span class="keywordtype">id</span>, VERTEX_ITERATOR *it);</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#a83c44bec5c8a95fd980391fb72c6be53">getVertexPos</a>(ID_TYPE &amp; <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;   <span class="keyword">inline</span> VERTEX_ITERATOR <a class="code" href="classTIGLContainersSubgraphBase.html#a610a858c82a1ac99a0db2b1b3fe4d404">getIndexedVertex</a>(ID_TYPE index);</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;   <span class="keyword">inline</span> VERTEX_ITERATOR <a class="code" href="classTIGLContainersSubgraphBase.html#a652a7bfb74caade265d2b2faabb33b78">begin</a>();</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;   <span class="keyword">inline</span> VERTEX_ITERATOR <a class="code" href="classTIGLContainersSubgraphBase.html#a57fc3d9252217c378f22173788e99a2b">end</a>();</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;   <span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#a87245814100827177d2382ac80b37600">size</a>();</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;   <span class="keyword">inline</span> VERTEX_LIST_PTR <a class="code" href="classTIGLContainersSubgraphBase.html#a6b06aa85e18d204308127164f1a12ab1">getVerticesPtr</a>();</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;   <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#a8649895f04c215f32442a3087c5c8cd3">isConnected</a>(ID_TYPE &amp; src, ID_TYPE &amp; target);</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;   <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classTIGLContainersSubgraphBase.html#aca8529bfd444ab738305122fd08664f3">isDirected</a>();</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#aa0d58cb49ff7fe169f56d9e933d63d13">memoryUsage</a>();</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;   <span class="keywordtype">void</span> <a class="code" href="classTIGLContainersSubgraphBase.html#ab9dafb37fe969bb2f7a2f13389140124">memory_usage</a>(uint_fast32_t &amp; sizeVerticesList, uint_fast32_t &amp; sizePos);</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;   uint_fast32_t <a class="code" href="classTIGLContainersSubgraphBase.html#aac204b3c1f12a1b1741b4b8c11635298">MaxCollision</a>();</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="preprocessor">#ifdef DEBUG_ENABLE</span></div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;   <span class="keywordtype">void</span> printBuffers();</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;   <span class="keywordtype">bool</span> checkConsistency();</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;};</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersSubgraphBaseImplementation_8hpp.html">tiglContainersSubgraphBaseImplementation.hpp</a>&quot;</span></div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* SUBGRAPH_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a6b753a0835bd3c53821161f728ff2ec7"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a6b753a0835bd3c53821161f728ff2ec7">TIGLContainersSubgraphBase::removeOutEdge</a></div><div class="ttdeci">bool removeOutEdge(ID_TYPE src, ID_TYPE target)</div><div class="ttdoc">Removes a single edge from the output edge buffer of the source vertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:649</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_abbcd66caf3a82f115e13ad0f0a02fa1e"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#abbcd66caf3a82f115e13ad0f0a02fa1e">TIGLContainersSubgraphBase::getNumVertices</a></div><div class="ttdeci">uint_fast32_t getNumVertices()</div><div class="ttdoc">Returns the total number of vertices in the subgraph. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:718</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_ae5e592a368623209324164edc1317c65"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#ae5e592a368623209324164edc1317c65">TIGLContainersSubgraphBase::findPos</a></div><div class="ttdeci">bool findPos(ID_TYPE &amp;id, uint_fast32_t &amp;pos)</div><div class="ttdoc">Finds the position of a given vertex (from its id) </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:259</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aa0d58cb49ff7fe169f56d9e933d63d13"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aa0d58cb49ff7fe169f56d9e933d63d13">TIGLContainersSubgraphBase::memoryUsage</a></div><div class="ttdeci">uint_fast32_t memoryUsage()</div><div class="ttdoc">Returns the approximate overall memory usage of the graph in MB. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:869</div></div>
<div class="ttc" id="classTIGLContainersPosInfo_html_ad4cd7f13b6c52337b28ce7032063d76d"><div class="ttname"><a href="classTIGLContainersPosInfo.html#ad4cd7f13b6c52337b28ce7032063d76d">TIGLContainersPosInfo::pos</a></div><div class="ttdeci">uint_fast32_t pos</div><div class="ttdoc">vertex position in vertex list </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:104</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a87245814100827177d2382ac80b37600"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a87245814100827177d2382ac80b37600">TIGLContainersSubgraphBase::size</a></div><div class="ttdeci">uint_fast32_t size()</div><div class="ttdoc">Returns the local number of vertices. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:812</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a83c44bec5c8a95fd980391fb72c6be53"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a83c44bec5c8a95fd980391fb72c6be53">TIGLContainersSubgraphBase::getVertexPos</a></div><div class="ttdeci">uint_fast32_t getVertexPos(ID_TYPE &amp;id)</div><div class="ttdoc">Returns the position of the vertex in the vertex list from its id. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:760</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aa1c6226429fec67e1dd4e7f368d9ede0"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aa1c6226429fec67e1dd4e7f368d9ede0">TIGLContainersSubgraphBase::removeInEdge</a></div><div class="ttdeci">bool removeInEdge(ID_TYPE src, ID_TYPE target)</div><div class="ttdoc">Removes a single edge from the input edge buffer of the target vertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:686</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a802c364b5f7d1d6b58ba1d85eec70003"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a802c364b5f7d1d6b58ba1d85eec70003">TIGLContainersSubgraphBase::removeVertex</a></div><div class="ttdeci">bool removeVertex(ID_TYPE &amp;id)</div><div class="ttdoc">Removes a single vertex (by id) from the subgraph. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:435</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a610a858c82a1ac99a0db2b1b3fe4d404"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a610a858c82a1ac99a0db2b1b3fe4d404">TIGLContainersSubgraphBase::getIndexedVertex</a></div><div class="ttdeci">VERTEX_ITERATOR getIndexedVertex(ID_TYPE index)</div><div class="ttdoc">Returns an iterator to a vertex from its position. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:776</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html">TIGLContainersSubgraphBase</a></div><div class="ttdoc">Core data container for a subgraph in each device. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:189</div></div>
<div class="ttc" id="classTIGLContainersPosInfo_html_a6aa7688f9791cd0049cabb4a583fb081"><div class="ttname"><a href="classTIGLContainersPosInfo.html#a6aa7688f9791cd0049cabb4a583fb081">TIGLContainersPosInfo::id</a></div><div class="ttdeci">ID_TYPE id</div><div class="ttdoc">vertex id </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:102</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aca8529bfd444ab738305122fd08664f3"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aca8529bfd444ab738305122fd08664f3">TIGLContainersSubgraphBase::isDirected</a></div><div class="ttdeci">bool isDirected()</div><div class="ttdoc">Returns true if the graph is directed, false otherwise. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:858</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_ac45e55c7e818ee8db6456ee80b54f4cb"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#ac45e55c7e818ee8db6456ee80b54f4cb">TIGLContainersSubgraphBase::DeallocPosTable</a></div><div class="ttdeci">void DeallocPosTable()</div><div class="ttdoc">Deallocates the position list. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:202</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_ad395cc63b17e2c2bed0e47c044d5aeea"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#ad395cc63b17e2c2bed0e47c044d5aeea">TIGLContainersSubgraphBase::posHoles</a></div><div class="ttdeci">vector&lt; uint_fast32_t &gt; posHoles</div><div class="ttdoc">posHoles: holes in the vertex list that should be exploited first in adding vertex ...</div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:235</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a36346fc960bbe56f1ce1ab9d0f9f9fca"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a36346fc960bbe56f1ce1ab9d0f9f9fca">TIGLContainersSubgraphBase::flagDirected</a></div><div class="ttdeci">bool flagDirected</div><div class="ttdoc">flagDirected: true if directed graph, false if undirected graph </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:237</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a19e7dea824e424684b5f4d7b75aa96df"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a19e7dea824e424684b5f4d7b75aa96df">TIGLContainersSubgraphBase::createVerticesList</a></div><div class="ttdeci">void createVerticesList(ID_TYPE &amp;numVertices)</div><div class="ttdoc">Creates vertex list with trivial vertices. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:388</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aaeab2fc8f6ebf89e4e055d92972e92da"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aaeab2fc8f6ebf89e4e055d92972e92da">TIGLContainersSubgraphBase::addVertex</a></div><div class="ttdeci">int addVertex(CVertex &amp;x)</div><div class="ttdoc">Adds a single vertex to the vertex list. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:286</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_af433f6fa9252112db0e30a3f5977a683"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#af433f6fa9252112db0e30a3f5977a683">TIGLContainersSubgraphBase::getVertex</a></div><div class="ttdeci">bool getVertex(ID_TYPE &amp;id, VERTEX_ITERATOR *it)</div><div class="ttdoc">Returns an iterator to a vertex from its id. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:743</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a57fc3d9252217c378f22173788e99a2b"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a57fc3d9252217c378f22173788e99a2b">TIGLContainersSubgraphBase::end</a></div><div class="ttdeci">VERTEX_ITERATOR end()</div><div class="ttdoc">Returns the end iterator of the vertex list. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:800</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aac204b3c1f12a1b1741b4b8c11635298"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aac204b3c1f12a1b1741b4b8c11635298">TIGLContainersSubgraphBase::MaxCollision</a></div><div class="ttdeci">uint_fast32_t MaxCollision()</div><div class="ttdoc">Returns the maximum collision in the hash table of the position. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:928</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a652a7bfb74caade265d2b2faabb33b78"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a652a7bfb74caade265d2b2faabb33b78">TIGLContainersSubgraphBase::begin</a></div><div class="ttdeci">VERTEX_ITERATOR begin()</div><div class="ttdoc">Returns the start iterator of the vertex list. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:788</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_adef090617cef9e01d43ed541e8944c80"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#adef090617cef9e01d43ed541e8944c80">TIGLContainersSubgraphBase::getNumEdges</a></div><div class="ttdeci">ID_TYPE getNumEdges()</div><div class="ttdoc">Returns the total number of edges of local vertices. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:729</div></div>
<div class="ttc" id="structTIGLContainersGraphTraits_html"><div class="ttname"><a href="structTIGLContainersGraphTraits.html">TIGLContainersGraphTraits</a></div><div class="ttdoc">Basic type definitions for TIGLContainersSubgraphBase class. </div><div class="ttdef"><b>Definition:</b> tiglContainersGraphTraits.hpp:64</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aa8d1a727fba68cd0778e11ba7a36a58e"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aa8d1a727fba68cd0778e11ba7a36a58e">TIGLContainersSubgraphBase::addInEdge</a></div><div class="ttdeci">bool addInEdge(ID_TYPE src, ID_TYPE target)</div><div class="ttdoc">Adds a single edge to the input edge buffer (if exists) of the target vertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:572</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_ab9dafb37fe969bb2f7a2f13389140124"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#ab9dafb37fe969bb2f7a2f13389140124">TIGLContainersSubgraphBase::memory_usage</a></div><div class="ttdeci">void memory_usage(uint_fast32_t &amp;sizeVerticesList, uint_fast32_t &amp;sizePos)</div><div class="ttdoc">Returns the detailed memory usage for the vertices and position buffers. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:899</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aa808fe135a0ae28b9b9538254b267d81"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aa808fe135a0ae28b9b9538254b267d81">TIGLContainersSubgraphBase::TIGLContainersSubgraphBase</a></div><div class="ttdeci">TIGLContainersSubgraphBase(bool isDireted=true, ID_TYPE assignedHashSize=0)</div><div class="ttdoc">Constructor of TIGLContainersSubgraphBase. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:116</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a8649895f04c215f32442a3087c5c8cd3"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a8649895f04c215f32442a3087c5c8cd3">TIGLContainersSubgraphBase::isConnected</a></div><div class="ttdeci">bool isConnected(ID_TYPE &amp;src, ID_TYPE &amp;target)</div><div class="ttdoc">Checks whether two vertices are connected. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:842</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a6b06aa85e18d204308127164f1a12ab1"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a6b06aa85e18d204308127164f1a12ab1">TIGLContainersSubgraphBase::getVerticesPtr</a></div><div class="ttdeci">VERTEX_LIST_PTR getVerticesPtr()</div><div class="ttdoc">Returns a pointer to the vertex list. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:827</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aca2763f8932ad1ec01be6f4db7231413"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aca2763f8932ad1ec01be6f4db7231413">TIGLContainersSubgraphBase::addOutEdge</a></div><div class="ttdeci">bool addOutEdge(ID_TYPE src, ID_TYPE target)</div><div class="ttdoc">Adds a single unweighted edge to the output edge buffer of the source vertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:492</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a7d861bdd7ba46573c8dc83f3bf1e4670"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a7d861bdd7ba46573c8dc83f3bf1e4670">TIGLContainersSubgraphBase::exist</a></div><div class="ttdeci">bool exist(ID_TYPE id)</div><div class="ttdoc">Checks the existence of a vertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:230</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a4d2dc5c71e000a5a43abfb541b99ea97"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a4d2dc5c71e000a5a43abfb541b99ea97">TIGLContainersSubgraphBase::posHashSize</a></div><div class="ttdeci">uint_fast32_t posHashSize</div><div class="ttdoc">the size of the position hash table </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:239</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_ae212d67e8129f85b2e4761aae98de3c0"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#ae212d67e8129f85b2e4761aae98de3c0">TIGLContainersSubgraphBase::reset</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">Initialization procedure. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:242</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_aaee9da2b9d250740c0407d449b2b3a4c"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#aaee9da2b9d250740c0407d449b2b3a4c">TIGLContainersSubgraphBase::hash</a></div><div class="ttdeci">ID_TYPE hash(ID_TYPE &amp;id)</div><div class="ttdoc">Gets the hashed position of a given id. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:216</div></div>
<div class="ttc" id="tiglContainersSubgraphBaseImplementation_8hpp_html"><div class="ttname"><a href="tiglContainersSubgraphBaseImplementation_8hpp.html">tiglContainersSubgraphBaseImplementation.hpp</a></div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a5833ead8d95633e6a1012b1e93e7b3aa"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a5833ead8d95633e6a1012b1e93e7b3aa">TIGLContainersSubgraphBase::addVertex_consistent</a></div><div class="ttdeci">bool addVertex_consistent(CVertex &amp;x)</div><div class="ttdoc">Adds a single vertex after checking its existence. </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBaseImplementation.hpp:417</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a03aff1a6c6f8bac92420673d84542e2a"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a03aff1a6c6f8bac92420673d84542e2a">TIGLContainersSubgraphBase::vertexPos</a></div><div class="ttdeci">POS_LIST_TYPE vertexPos</div><div class="ttdoc">vertexPos: holds the position of each vertex in the adjacancy list </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:233</div></div>
<div class="ttc" id="classTIGLContainersSubgraphBase_html_a56b37400e7d47e6a278084defcd26778"><div class="ttname"><a href="classTIGLContainersSubgraphBase.html#a56b37400e7d47e6a278084defcd26778">TIGLContainersSubgraphBase::vertexList</a></div><div class="ttdeci">VERTEX_LIST_TYPE vertexList</div><div class="ttdoc">vertexList: holds the physical storage of the subgraph </div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:231</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html"><div class="ttname"><a href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">Core vertex class. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:89</div></div>
<div class="ttc" id="classTIGLContainersPosInfo_html"><div class="ttname"><a href="classTIGLContainersPosInfo.html">TIGLContainersPosInfo</a></div><div class="ttdoc">Contains position information for each vertex which is stored in the position hash table...</div><div class="ttdef"><b>Definition:</b> tiglContainersSubgraphBase.hpp:75</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
